package com.perdemia.permissionanalyzer.application.handlers.menu;

import com.perdemia.permissionanalyzer.application.parts.FilePart;
import com.perdemia.permissionanalyzer.data.FileInfo;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.ESelectionService;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.program.Program;
import org.eclipse.swt.widgets.Shell;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class OpenInExplorerHandler {
	private static final Logger logger = LoggerFactory.getLogger(OpenInExplorerHandler.class.getName());
	
	@Execute
	public void execute(Shell shell, EPartService partService, ESelectionService selectionService){
		StructuredSelection selection = (StructuredSelection) selectionService.getSelection(FilePart.ID);
		FileInfo file = (FileInfo) selection.getFirstElement();
		
		// determine file path
		if (file != null) {
			String filePath = file.determineFullPath();
			Program.launch(filePath);
		}
	}
}
