package com.perdemia.permissionanalyzer.application.handlers.menu;

import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import org.eclipse.core.commands.ParameterizedCommand;
import org.eclipse.e4.core.commands.ECommandService;
import org.eclipse.e4.core.commands.EHandlerService;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.workbench.IWorkbench;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Shell;

import com.perdemia.permissionanalyzer.application.jface.dialogs.SyncMessageDialog;
import com.perdemia.permissionanalyzer.application.jface.wizard.policy.CreatePolicyWizardDialog;

public class OpenPolicyWizardHandler {
	@Inject private ECommandService commandService;
	@Inject private EHandlerService handlerService;
	
	@Execute
	public void execute(MApplication application, final Shell shell, final IWorkbench workbench) {
		CreatePolicyWizardDialog wizardDialog = new CreatePolicyWizardDialog(shell);
		if (wizardDialog.open() == IDialogConstants.FINISH_ID) {
			SyncMessageDialog.showMessage(MessageDialog.INFORMATION, "Policy created", "Your policy has been created. You can view the status and details of your policies in the dialog Manage Policies. Use the context menu in this dialog to perform different actions on the policy, like running the policy, editing the details or loading the policy in the application.");
			
			Map<String, Object> parameters = new HashMap<String, Object>();
			parameters.put("com.perdemia.permissionanalyzer.application.commands.managereports.param.ispolicy", "true");
			ParameterizedCommand managePoliciesCommand = commandService.createCommand("com.perdemia.permissionanalyzer.application.commands.managereports", parameters);
			handlerService.executeHandler( managePoliciesCommand );
		}
	}	
}