 
package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import javax.annotation.PostConstruct;

import com.perdemia.permissionanalyzer.application.parts.FilePart;
import com.perdemia.permissionanalyzer.application.util.ColorFactory;
import com.perdemia.permissionanalyzer.application.util.ColorFactory.AppColor;
import com.perdemia.permissionanalyzer.application.util.ImageFactory;
import com.perdemia.permissionanalyzer.application.util.ImageFactory.AppImage;

import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.e4.ui.workbench.modeling.ESelectionService;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;

public class ApplyFilterToolControl {
	private boolean checked = true;
	
	@PostConstruct
	public void createGui(final Composite parent, final EPartService partService, final ESelectionService selectionService) {		
		final Button button = new Button(parent, SWT.CHECK);
		button.setText("Apply filter on the list");
		button.setImage(ImageFactory.getInstance().getImage(AppImage.FILTER_20X20));
		button.setSelection(true);		
		button.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				checked = button.getSelection();
				
				//Triggers a refresh in the Part by settings the selected FileInfo in the SelectionService
				MPart part = partService.findPart(FilePart.ID);
				FilePart fileTreePart = (FilePart) part.getObject();
				final TreeViewer viewer = fileTreePart.getTreeViewer();
				selectionService.setSelection(viewer.getSelection());
			}
		});
	}

	public boolean isChecked() {
		return checked;
	}
	/**
	 * Triggers a refresh in the ACL Part by settings the selected FileInfo in the SelectionService
	 *  
	 * @param partService
	 * @param selectionService
	 */
	@Execute
	public void execute(EPartService partService, ESelectionService selectionService) {
		
	}
		
}