package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import javax.annotation.PostConstruct;

import com.perdemia.permissionanalyzer.application.util.ColorFactory;
import com.perdemia.permissionanalyzer.application.util.ColorFactory.AppColor;
import com.perdemia.permissionanalyzer.application.util.FilterHelper;

import org.eclipse.core.commands.ParameterizedCommand;
import org.eclipse.e4.core.commands.ECommandService;
import org.eclipse.e4.core.commands.EHandlerService;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

public class QuickFileSearchToolControl {
	
	@PostConstruct
	@SuppressWarnings("restriction")
	public void createGui(final Composite parent, final ECommandService commandService, final EHandlerService handlerService) {
		Label label = new Label(parent, SWT.NONE);
		//label.setForeground(ColorFactory.getInstance().getColor(AppColor.WHITE));
		label.setText("                    Quick file search:   ");
		label.setToolTipText("Search on file name in the current overview, use * as wildcard");
		
		final Text searchText = new Text(parent, SWT.BORDER);
		searchText.setMessage("search on file name");
		searchText.setToolTipText("Search on file name in the current overview, use * as wildcard");
		searchText.addKeyListener(new KeyAdapter() {
			@Override
			public void keyReleased(KeyEvent e) {
				if (e.keyCode == SWT.CR) {
					// trigger the command of the search button
					ParameterizedCommand quickSearchCommand = commandService.createCommand("com.perdemia.permissionanalyzer.application.commands.quicksearch", null);
					handlerService.executeHandler( quickSearchCommand );
				}
			}
		});
		
		// Easy reference to the text box, which is used in the QuickFileSearchHandler
		FilterHelper.getInstance().setQuickFileSearchText(searchText);
	}
}