package com.perdemia.permissionanalyzer.application.handlers.toolbar;

import java.util.HashMap;
import java.util.Map;

import com.perdemia.permissionanalyzer.application.parts.FilePart;
import com.perdemia.permissionanalyzer.application.util.LicenseHelper;
import com.perdemia.permissionanalyzer.application.util.LicenseHelper.Edition;
import com.perdemia.permissionanalyzer.data.Member;

import org.eclipse.core.commands.ParameterizedCommand;
import org.eclipse.e4.core.commands.ECommandService;
import org.eclipse.e4.core.commands.EHandlerService;
import org.eclipse.e4.core.di.annotations.CanExecute;
import org.eclipse.e4.core.di.annotations.Execute;
import org.eclipse.e4.core.services.events.IEventBroker;
import org.eclipse.e4.ui.model.application.MApplication;
import org.eclipse.e4.ui.model.application.ui.basic.MPart;
import org.eclipse.e4.ui.model.application.ui.menu.MToolItem;
import org.eclipse.e4.ui.workbench.UIEvents;
import org.eclipse.e4.ui.workbench.modeling.EModelService;
import org.eclipse.e4.ui.workbench.modeling.EPartService;
import org.eclipse.swt.layout.GridData;

public class UseTableViewHandler {
	
	@Execute
	public void execute(MApplication app, EPartService partService, EModelService modelService, MToolItem toolItem, ECommandService commandService, EHandlerService handlerService, IEventBroker eventBroker){
		if (toolItem.isSelected()) {
			MPart part = partService.findPart(FilePart.ID);
			FilePart fileTreePart = (FilePart) part.getObject();
			GridData treeGridData = (GridData) fileTreePart.getTreeViewer().getTree().getLayoutData();
			GridData tableGridData = (GridData) fileTreePart.getTableViewer().getTable().getLayoutData();
			
			// hide the tree and show the table
			treeGridData.exclude = true;
			fileTreePart.getTreeViewer().getTree().setVisible(false);
			tableGridData.exclude = false;
			fileTreePart.getTableViewer().getTable().setVisible(true);
			fileTreePart.getTableViewer().getTable().getParent().layout(true);
			
			// trigger the toolbar items canExecute methods
			eventBroker.send(UIEvents.REQUEST_ENABLEMENT_UPDATE_TOPIC, UIEvents.ALL_ELEMENT_ID);
			
			// refresh the data (if necessary)
			Map<String, Object> params = new HashMap<String, Object>();
			params.put("com.perdemia.permissionanalyzer.application.commands.applyfilter.param.onlyapplywhenempty", "true");
			ParameterizedCommand applyFilterCommand = commandService.createCommand("com.perdemia.permissionanalyzer.application.commands.applyfilter", params);
			handlerService.executeHandler( applyFilterCommand );
		}
	}
	
	@CanExecute
	public boolean canExecute() {
		return Member.isUserGroupCountAllowed() && !LicenseHelper.getEdition().equals(Edition.SCAN_AGENT);
	}
}
