package com.perdemia.permissionanalyzer.application.jface.labelproviders;

import org.eclipse.jface.viewers.ColumnLabelProvider;
import org.eclipse.swt.graphics.Color;

import com.perdemia.permissionanalyzer.application.util.ColorFactory;
import com.perdemia.permissionanalyzer.application.util.ColorFactory.AppColor;
import com.perdemia.permissionanalyzer.application.util.PermissionUtil;
import com.perdemia.permissionanalyzer.data.AclItem;
import com.perdemia.permissionanalyzer.data.FileInfo;

public class PermissionLabelProvider extends ColumnLabelProvider {
	@Override
	public String getText(Object element) {
		if (element instanceof FileInfo) {
			FileInfo file = (FileInfo) element;
			return PermissionUtil.effectivePermissionsToString(file.getEffectivePermissions(), file.isDirectory());
		} else {
			return "Unknown type";
		}
	}
	
	@Override
	public Color getForeground(Object element) {
		if (element instanceof FileInfo) {
			FileInfo file = (FileInfo) element;
			
			boolean allImplicit = true;
			for (AclItem aclItem : file.getEffectivePermissions().getPermissions().values()) {
				allImplicit = allImplicit && aclItem.isFlagInheritedAce();
			}
			
			//determine permission text
			if (allImplicit) {
				return ColorFactory.getInstance().getColor(AppColor.GREY);
			}
		}
		
		return null;
	}
}