package com.perdemia.permissionanalyzer.application.logging;

import org.eclipse.core.runtime.ILogListener;
import org.eclipse.core.runtime.IStatus;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class EclipseLogListener implements ILogListener {
	public static Logger logger = LoggerFactory.getLogger(EclipseLogListener.class.getName());

	@Override
	public void logging(IStatus status, String plugin) {
		if (status.getSeverity() == IStatus.WARNING) {
			logger.warn(status.getMessage());
		} else if (status.getSeverity() == IStatus.ERROR) {
			if (status.getException() == null) {
				logger.error(status.getMessage());
			} else {
				logger.error(status.getMessage(), status.getException());
			}
		} else if (status.getSeverity() == IStatus.INFO && logger.isInfoEnabled()) {
			logger.info(status.getMessage());
		}
	}
}
