package com.perdemia.permissionanalyzer.application.model;

public class LdapOUInfo {
	private int ldapOUId;
	private LdapConnectionInfo connection;
	private String baseOU;
	private SearchScope searchScope;
	private SearchObjectType searchObjectType;
	
	/** A LdapOUInfo object (configured in the Scan View) can be temporarily excluded from the scan */
	private boolean enabled;
	
	/** Search scope used in the LDAP Search Request */
	public enum SearchScope {
		CONTAINER_AND_SUBS, ONLY_SUBS, ONE_LEVEL_SUBS_NOT_CONTAINER_ITSELF, ONLY_CONTAINER
	}
	
	/** Search objects, users and/or groups */
	public enum SearchObjectType {
		USERS_GROUPS, USERS, GROUPS
	}

	public LdapConnectionInfo getConnection() {
		return connection;
	}

	public void setConnection(LdapConnectionInfo connection) {
		this.connection = connection;
	}

	public String getBaseOU() {
		return baseOU;
	}

	public void setBaseOU(String baseOU) {
		this.baseOU = baseOU;
	}

	public SearchScope getSearchScope() {
		return searchScope;
	}

	public void setSearchScope(SearchScope searchScope) {
		this.searchScope = searchScope;
	}

	public SearchObjectType getSearchObjectType() {
		return searchObjectType;
	}

	public void setSearchObjectType(SearchObjectType searchObjectType) {
		this.searchObjectType = searchObjectType;
	}

	public int getLdapOUId() {
		return ldapOUId;
	}

	public void setLdapOUId(int ldapOUId) {
		this.ldapOUId = ldapOUId;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("LdapOUInfo [ldapOUId=");
		builder.append(ldapOUId);
		builder.append(", connection=");
		builder.append(connection);
		builder.append(", baseOU=");
		builder.append(baseOU);
		builder.append(", searchScope=");
		builder.append(searchScope);
		builder.append(", searchObjectType=");
		builder.append(searchObjectType);
		builder.append("]");
		return builder.toString();
	}

	public boolean isEnabled() {
		return enabled;
	}

	public void setEnabled(boolean enabled) {
		this.enabled = enabled;
	}
}
