package com.perdemia.permissionanalyzer.application.swt;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Display;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class AnimatedImage implements Runnable {
	private static Logger logger = LoggerFactory.getLogger(AnimatedImage.class.getName());
	private ImageComposite imageComposite;
	private Image[] images;
	private boolean isStopped;
	private int index;
	
	public AnimatedImage(ImageComposite imageComposite, Image[] images) {
		this.imageComposite = imageComposite;
		setImages(images);
	}

	public void stop() {
		isStopped = true;
	}

	public void start() {
		isStopped = false;
		Thread thread = new Thread(this);
		thread.start();
	}

	public void run() {
		try {
			index = 0;
			while (imageComposite != null && !isStopped) {
				Display.getDefault().asyncExec(new Runnable(){
					public void run(){
						if(!imageComposite.isDisposed() && imageComposite !=null){
							imageComposite.setImage(images[index]);
						}
					}
				});
				Thread.sleep(500);
				index = ++index % images.length;
			}
		} catch (InterruptedException e) {
			logger.error("Error while running image animation", e);
		}
	}
		
	public void setImages(Image[] images) {
		this.images = images;
		imageComposite.setImage(images[0]);
		index = 0;
	}
}
