package com.perdemia.permissionanalyzer.application.util;

import com.license4j.ActivationStatus;
import com.license4j.License;
import com.license4j.LicenseText;
import com.license4j.ValidationStatus;

public class PerdemiaLicense extends License {
	LicenseText licenseText = new LicenseText();
	
	private final long MS_PER_DAY = 24*60*60*1000;
	
	public PerdemiaLicense(){
		super(ValidationStatus.LICENSE_INVALID);
		
		licenseText.setActivationID(8376154283762L);
		licenseText.setLicenseQuantity(1);
		licenseText.setActivationRequired(true);
	}

	public ValidationStatus getValidationStatus() {
		long creationTime = licenseText.getLicenseGenerationDateTime();
		long validityTime = licenseText.getLicenseValidityPeriod() * MS_PER_DAY;
		
		return creationTime + validityTime > System.currentTimeMillis() ? ValidationStatus.LICENSE_VALID : ValidationStatus.LICENSE_EXPIRED;
	}

	public LicenseText getLicenseText() {
		return licenseText;
	}
	
	@Override
	public ActivationStatus getActivationStatus() {
		if (licenseText.isActivationCompleted() && getValidationStatus().equals(ValidationStatus.LICENSE_VALID)) {
			return ActivationStatus.ACTIVATION_COMPLETED;
		} else {
			return ActivationStatus.DEACTIVATION_COMPLETED;
		}
	}
	
	@Override
	public boolean isActivationCompleted() {
		return licenseText.isActivationCompleted();
	}
	
	@Override
	public boolean isActivationRequired() {
		return licenseText.isActivationRequired();
	}
}
