package com.perdemia.permissionanalyzer.data;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class Rdn extends DBObject {
private final static Logger logger = LoggerFactory.getLogger(Rdn.class.getName());
	
	/** Table attributes */
	private final static String[] tableAttributes = new String[]{"RDN"};
	
	/** Table fields */
	private String rdn;
	
	/**
	 * The last ID that was used for an INSERT of this class in the database. If 0 is returned then the
	 * {@link DBObject#insert()} method will retrieve the max ID from the database.
	 */
	private static int lastId;
	
	public Rdn(){}
	
	public Rdn(String rdn) {
		this.rdn = rdn;
	}
	//========================================
	// GENERAL DB ACTIONS
	//========================================
	
	public static Rdn getById(Integer id) throws DBException {
		return (Rdn) getById(Rdn.class, id);
	}
		
	@SuppressWarnings("unchecked")
	public static List<Rdn> where(String whereClause, Object[] parameters) throws DBException {
		return where(Rdn.class, whereClause, parameters, null, 0);
	}
	
	@SuppressWarnings("unchecked")
	public static List<Rdn> where(String whereClause, Object[] parameters, String orderBy) throws DBException {
		return where(Rdn.class, whereClause, parameters, orderBy, 0);
	}
	
	@SuppressWarnings("unchecked")
	public static List<Rdn> where(String whereClause, Object[] parameters, String orderBy, int limit) throws DBException {
		return where(Rdn.class, whereClause, parameters, orderBy, limit);
	}
	
	public static Rdn findFirst(String whereClause, Object... parameters) throws DBException {
		return (Rdn) findFirst(Rdn.class, whereClause, parameters);
	}
	
	public static int delete(Integer id) throws DBException {
		return delete(Rdn.class, id);
	}
	
	public static int delete(String whereClause, Object...parameters) throws DBException {
		return delete(Rdn.class, whereClause, parameters);
	}
	
	@Override
	protected String[] getTableAttributes(){
		return tableAttributes;
	}
	
	@Override
	protected void buildObject(ResultSet rs) throws SQLException {
		id = (rs.getInt("id"));
		rdn = rs.getString(tableAttributes[0]);		
	}
	
	@Override
	protected void setQueryParameters(PreparedStatement ps) throws SQLException {
		ps.setString(1, rdn);
	}
	
	//========================================
	// GETTERS AND SETTERS
	//========================================
	
	public String getRdn() {
		return rdn;
	}

	public void setRdn(String rdn) {
		this.rdn = rdn;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("Rdn [rdn=");
		builder.append(rdn);
		builder.append(", id=");
		builder.append(id);
		builder.append("]");
		return builder.toString();
	}
	
	@Override
	public int getLastId() {
		return lastId;
	}

	@Override
	public void setLastId(int lastId) {
		Rdn.lastId = lastId;
	}	
}
