package com.perdemia.permissionanalyzer.data;

import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.List;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;


public class ReportComparator2 extends DBObject {
private final static Logger logger = LoggerFactory.getLogger(ReportComparator2.class.getName());
	
	/** Table attributes */
	private final static String[] tableAttributes = new String[]{"REPORT2_ROW_KEY", "REPORT2_ROW_VALUE"};
	
	/** Table fields */
	private String reportRowKey;
	private String reportRowValue;
	
	/**
	 * The last ID that was used for an INSERT of this class in the database. If 0 is returned then the
	 * {@link DBObject#insert()} method will retrieve the max ID from the database.
	 */
	private static int lastId;
	
	public ReportComparator2(){}
	
	public ReportComparator2(String reportRowKey, String reportRowValue) {
		this.reportRowKey = reportRowKey;
		this.reportRowValue = reportRowValue;
	}
	
	
	//========================================
	// GENERAL DB ACTIONS
	//========================================
	
	@SuppressWarnings("unchecked")
	public static List<ReportComparator2> getAll() throws DBException {
		return (List<ReportComparator2>) getAll(ReportComparator2.class, "REPORTCOMPARATOR2", 0);
	}
	
	public static ReportComparator2 getById(Integer id) throws DBException {
		return (ReportComparator2) getById(ReportComparator2.class, id);
	}
		
	@SuppressWarnings("unchecked")
	public static List<ReportComparator2> where(String whereClause, Object[] parameters) throws DBException {
		return where(ReportComparator2.class, whereClause, parameters, null, 0);
	}
	
	@SuppressWarnings("unchecked")
	public static List<ReportComparator2> where(String whereClause, Object[] parameters, String orderBy) throws DBException {
		return where(ReportComparator2.class, whereClause, parameters, orderBy, 0);
	}
	
	@SuppressWarnings("unchecked")
	public static List<ReportComparator2> where(String whereClause, Object[] parameters, String orderBy, int limit) throws DBException {
		return where(ReportComparator2.class, whereClause, parameters, orderBy, limit);
	}
	
	public static ReportComparator2 findFirst(String whereClause, Object... parameters) throws DBException {
		return (ReportComparator2) findFirst(ReportComparator2.class, whereClause, parameters);
	}
	
	public static int delete(Integer id) throws DBException {
		return delete(ReportComparator2.class, id);
	}
	
	public static int delete(String whereClause, Object...parameters) throws DBException {
		return delete(ReportComparator2.class, whereClause, parameters);
	}
	
	@Override
	protected String[] getTableAttributes(){
		return tableAttributes;
	}
	
	@Override
	protected void buildObject(ResultSet rs) throws SQLException {
		id = (rs.getInt("id"));
		reportRowKey = getNullAsEmptyString(rs, tableAttributes[0]);		
		reportRowValue = getNullAsEmptyString(rs, tableAttributes[1]);
	}
	
	@Override
	protected void setQueryParameters(PreparedStatement ps) throws SQLException {
		ps.setString(1, reportRowKey);
		ps.setString(2, reportRowValue);
	}
	
	//========================================
	// GETTERS AND SETTERS
	//========================================
	
	
	@Override
	public int getLastId() {
		return lastId;
	}

	@Override
	public void setLastId(int lastId) {
		ReportComparator2.lastId = lastId;
	}

	public String getReportRowKey() {
		return reportRowKey;
	}

	public void setReportRowKey(String reportRowKey) {
		this.reportRowKey = reportRowKey;
	}

	public String getReportRowValue() {
		return reportRowValue;
	}

	public void setReportRowValue(String reportRowValue) {
		this.reportRowValue = reportRowValue;
	}

	@Override
	public String toString() {
		StringBuilder builder = new StringBuilder();
		builder.append("ReportComparator2 [reportRowKey=");
		builder.append(reportRowKey);
		builder.append(", reportRowValue=");
		builder.append(reportRowValue);
		builder.append("]");
		return builder.toString();
	}
	
}
