package com.perdemia.permissionanalyzer.data.util;

import java.sql.ResultSet;
import java.sql.SQLException;

import com.perdemia.permissionanalyzer.data.DBException;

public interface CustomProcessor {
	/**
	 * Is called for each ResultSet found in the given PreparedStatement.
	 * 
	 * @param rs
	 * 
	 * @return true in case the caller must continue processing the next record set. When false, the iterator will stop.
	 * 
	 * @throws SQLException
	 * @throws DBException
	 */
	boolean processResultSet(ResultSet rs) throws SQLException, DBException;
}
