package com.perdemia.permissionanalyzer.data.util;

import java.util.HashMap;
import java.util.Map;

import com.perdemia.permissionanalyzer.data.DBObject;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class TableCountCache {
	private static final Logger logger = LoggerFactory.getLogger(TableCountCache.class.getName());
	
	/** Map for the table count of the different DBObjects */
	private static final Map<Class<? extends DBObject>, Integer> counts = new HashMap<Class<? extends DBObject>, Integer>();
		
	/**
	 * Clears the Map of the cache and forces a refresh from the database whenever the cache is used.
	 */
	public static void clearCache() {
		counts.clear();
	}
	
	public static Integer getCount(Class<? extends DBObject> clazz) {
		return counts.get(clazz);
	}
	
	public static void cacheCount(Class<? extends DBObject> clazz, Integer count) {
		counts.put(clazz, count);
	}
}